<?php
/*
Plugin Name: Plastic Tunes
Version: 1.4
Plugin URI: http://unalignedcode.wordpress.com/plastic_tunes/
Description: A Multi-User "Now Playing" plugin that accepts input from iTunes, WinAmp, and many more. Saves your information to your DB and will accomodate multiple users. Widget compatible and highly customizable.
Author: unalignedcoder
Author URI: http://unalignedcode.wordpress.com
License: GPL compatible
*/

/* A big thanks goes out the Ken Smith's "muTunes" Plugin, on which this is directly taken. */

global $wpdb;
if ( !$wpdb ) die('This template cannot be called directly.');

$dir = basename(dirname(__FILE__));
if ($dir == 'plugins') $dir = '';
else $dir = $dir . '/';	
define("PLASTIC_PATH", get_option("siteurl") . "/wp-content/plugins/" . $dir);

// Create song table, if doesn't exist
$wpdb->query('
CREATE TABLE IF NOT EXISTS `'.$wpdb->prefix.'plastic_tunes` (
`id` BIGINT NOT NULL AUTO_INCREMENT ,
`user_id` INT NOT NULL ,
`created` TIMESTAMP ,
`artist` VARCHAR(255) NULL ,
`album` VARCHAR(255) NULL ,
`title` VARCHAR(255) NULL ,
`rating` INT NULL ,
`year` VARCHAR(255) NULL,
`track` INT NULL,
`genre` VARCHAR(255) NULL,
`duration` VARCHAR(255) NULL,
PRIMARY KEY ( `id` )
) TYPE = MYISAM
');

$dir = basename(dirname(__FILE__));

// Set up default options
add_option('plastic_tunes_sidebar_format_string', '<li>%title% by <strong>%artist%</strong> - %time_ago%</li>');
add_option('plastic_tunes_sidebar_count', 1);
add_option('plastic_tunes_sidebar_outer_tag', '</ul>');
add_option('plastic_tunes_sidebar_title', '<h3>What %name% is listening to:</h3><ul>');
add_option('plastic_tunes_togglesidebar_if', 'Y');
add_option('plastic_tunes_togglesidebar_manual', '');
add_option('plastic_tunes_sidegoogle', 'Y');

add_option('plastic_tunes_player_state', '');

add_option('plastic_tunes_index_count', 20);
add_option('plastic_tunes_index_title', '<h3>What %name% is listening to:</h3>');
add_option('plastic_tunes_indexgoogle', 'Y');
add_option('plastic_tunes_tableclass', PLASTIC_PATH . '/plastic.css');
add_option('plastic_tunes_skip_repeats', '');

add_option('plastic_tunes_min_user_level', '1');
add_option('plastic_tunes_post_password', '(change this)');

add_option('plastic_tunes_format_date', '%d %b %y %h:%i %A');
add_option('plastic_tunes_db_timezone_offset', '0');
add_option('plastic_tunes_srv_timezone_offset', '0');
add_option('plastic_tunes_flood_protection_secs', '20');
add_option('plastic_tunes_userlist_text', 'Users with song data...');

add_option('plastic_tunes_showtitle', 'Y');
add_option('plastic_tunes_showartist', 'Y');
add_option('plastic_tunes_showalbum', 'Y');
add_option('plastic_tunes_showyear', '');
add_option('plastic_tunes_showgenre', '');
add_option('plastic_tunes_showtrack', '');
add_option('plastic_tunes_showratings', 'Y');
add_option('plastic_tunes_showdate', 'Y');
add_option('plastic_tunes_showlastedtime', '');
add_option('plastic_tunes_showduration', 'Y');
add_option('plastic_tunes_shownav', 'Y');

add_option('plastic_tunes_widget_id', 0);
add_option('plastic_tunes_widget_title', '');


include ('plastic_functions.php');
include ('plastic_pages.php');


//add headers
function plastic_header() {

	echo "\n" . '<link rel="stylesheet" type="text/css" href="' . PLASTIC_PATH . 'plastic.css" />';	
	
	/*e	echo "\n" . '<script type="text/javascript"> function overMe(a){ var e=document.getElementById(a); e.style.display="block"} </script>';
	
	echo "\n" . '<script type="text/javascript"> function outMe(a){ var e=document.getElementById(a); e.style.display="none" } </script>';
*/
	
	echo "\n" . '<script type="text/javascript"> function toggleMe(a){ var e=document.getElementById(a); if(!e)return true; if(e.style.display=="block"){ e.style.display="none" } else{ e.style.display="block" } return true; } </script>';
	
	
	
}


// Add the various sub-menus of the admin panel.
function plastic_tunes_add_pages() {
	add_options_page('Plastic Tunes', 'Plastic Tunes', 9, basename(__FILE__), 'plastic_tunes_options');
	add_management_page('Plastic Tunes', 'Plastic Tunes', 9, basename(__FILE__), 'plastic_tunes_manage');
}

// Let's do the widget for the lazy customizer.
function plastic_tunes_widget_init() {

	if ( !function_exists('register_sidebar_widget') )
		return;

	function plastic_tunes_widget($args) {
		extract($args);
		
		/* here we empty the 'before' and 'after' widget vars if the widget title is 
		not empty ( which would mean overridden by the general plastic tune option for the sidbear element). */
		if ( !get_option('plastic_tunes_widget_title')) {
			$before_widget = '';
			$before_title = '';
			$after_title = '';
			$after_widget = '';
		}
		
		echo $before_widget;
		
		//retrieve title		
		echo $before_title . get_option('plastic_tunes_widget_title') . $after_title;

		//retrieve the main thing unless there is no USER ID
		if ( !get_option('plastic_tunes_widget_id')) return;
		else {plastic_sidebar(get_option('plastic_tunes_widget_id'));}
		
		echo $after_widget;
	}
		
	function plastic_tunes_widget_control() {
	
		//update options from the form
		//update options from the form
		if ( $_POST['plastic_tunes_submit'] ) {
			if (is_numeric($_POST['plastic_tunes_widget_id'])) {
				$get_id = ($_POST['plastic_tunes_widget_id']);
			}
			else {
				$get_id = get_option('plastic_tunes_widget_id');
			}
			
			$get_title = strip_tags(stripslashes($_POST['plastic_tunes_widget_title']));
			update_option('plastic_tunes_widget_id', $_POST['plastic_tunes_widget_id'] );
			update_option('plastic_tunes_widget_title', $_POST['plastic_tunes_widget_title'] );
		}
		else {
			$get_id = get_option('plastic_tunes_widget_id');
			$get_title = get_option('plastic_tunes_widget_title');
		}
		
		$user_id =  htmlspecialchars($get_id, ENT_QUOTES);
		$title = htmlspecialchars($get_title, ENT_QUOTES);
		
		// form: insert user_id
		echo '<p style="text-align:left;><label for="plastic_tunes_widget_id">' . __('USER ID') 
		. ' <input style="width: 40px;" id="plastic_tunes_widget_id" name="plastic_tunes_widget_id" type="text" value="'.$user_id.'" /></label><br/>
		<em>The ID number is needed for the sidebar widget to work. You can retrieve it from the plastic tunes options page.</em></p>';
		
		// form: insert title
		echo '<p style="text-align:left;"><label for="plastic_tunes_widget_title">' . __('Title of the widget:') 
		. ' <input style="width: 200px;" id="plastic_tunes_widget_title" name="plastic_tunes_widget_title" type="text" value="'.$title.'" /></label><br/>
		<em>Using this field will override the title field in the sidebar area of the plastic tunes option page. To keep using that one, leave this textbox empty. 
		See option page for more infos.
		</em></p>';
		
		//end form
		echo '<input type="hidden" id="plastic_tunes_submit" name="plastic_tunes_submit" value="1" />';
	}
	
	// This registers our widget so it appears with the other available
	// widgets and can be dragged and dropped into any active sidebars.
	register_sidebar_widget(array('Plastic Tunes', 'widgets'), 'plastic_tunes_widget');

	// This registers our optional widget control form. Because of this
	// our widget will have a button that reveals a 300x100 pixel form.
	register_widget_control(array('Plastic Tunes', 'widgets'), 'plastic_tunes_widget_control', 350, 250);
}

add_action('admin_menu', 'plastic_tunes_add_pages');
add_action('admin_head', 'plastic_header');
// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'plastic_tunes_widget_init');

?>
